package ch.epfl.ppo.collections;

import java.util.Iterator;

public final class TreeSet<E extends Comparable<E>> implements Set<E> {
    private int size = 0;
    private Node<E> root = null;

    @Override
    public boolean isEmpty() {
        return size == 0;
    }

    @Override
    public int size() {
        return size;
    }

    @Override
    public void add(E newElem) {
        // TODO à faire
    }

    @Override
    public void remove(E elem) {
        // TODO à faire
    }

    @Override
    public boolean contains(E elem) {
        return nodeFor(elem) != null;
    }

    @Override
    public Iterator<E> iterator() {
        // TODO à faire
        return null;
    }

    private Node<E> nodeOrParentFor(E elem) {
        Node<E> n = root, p = null;
        while (n != null) {
            int cmp = elem.compareTo(n.elem);
            p = n;
            if (cmp < 0) n = n.smaller;
            else if (cmp > 0) n = n.greater;
            else return n;
        }
        return p;
    }

    private Node<E> nodeFor(E elem) {
        Node<E> nodeOrParent = nodeOrParentFor(elem);
        return nodeOrParent != null && nodeOrParent.elem.equals(elem)
                ? nodeOrParent
                        : null;
    }

    private static <E> Node<E> successor(Node<E> n) {
        if (n.greater != null) {
            Node<E> s = n.greater;
            while (s.smaller != null)
                s = s.smaller;
            return s;
        } else {
            Node<E> s = n.parent;
            Node<E> c = n;
            while (s != null && s.greater == c) {
                c = s;
                s = s.parent;
            }
            return s;
        }
    }

    private final static class Node<E> {
        public E elem;
        public Node<E> parent;
        public Node<E> smaller, greater;

        public Node(Node<E> parent, Node<E> smaller, E elem, Node<E> greater) {
            this.parent = parent;
            this.smaller = smaller;
            this.elem = elem;
            this.greater = greater;
        }

        public Node(Node<E> parent, E elem) {
            this(parent, null, elem, null);
        }

        public Node(E value) {
            this(null, null, value, null);
        }
    }
}
